Index: codes/icosagcm/trunk/src/caldyn_gcm.f90
===================================================================
--- codes/icosagcm/trunk/src/caldyn_gcm.f90	(revision 150)
+++ codes/icosagcm/trunk/src/caldyn_gcm.f90	(revision 151)
@@ -1,5 +1,5 @@
 MODULE caldyn_gcm_mod
   USE icosa
-
+  USE transfert_mod
   PRIVATE
 
@@ -11,7 +11,17 @@
   TYPE(t_field),POINTER :: f_buf_v(:), f_buf_s(:), f_buf_p(:)
 
-  PUBLIC init_caldyn, caldyn, write_output_fields,un2ulonlat
-
+! temporary shared variable for caldyn
+  TYPE(t_field),POINTER :: f_theta(:)
+  TYPE(t_field),POINTER :: f_pk(:)
+  TYPE(t_field),POINTER :: f_pks(:)
+  TYPE(t_field),POINTER :: f_phi(:)
+  TYPE(t_field),POINTER :: f_divm(:)
+  TYPE(t_field),POINTER :: f_wwuu(:)
+   
   INTEGER :: caldyn_hydrostat, caldyn_conserv
+  
+  TYPE(t_message) :: req_ps, req_theta_rhodz, req_u, req_qu
+
+  PUBLIC init_caldyn, caldyn, write_output_fields,req_ps
 
 CONTAINS
@@ -69,16 +79,23 @@
   IMPLICIT NONE
 
-  CALL allocate_field(f_out_u,field_u,type_real,llm) 
-  CALL allocate_field(f_p,field_t,type_real,llm+1)
-  CALL allocate_field(f_rhodz,field_t,type_real,llm) 
-  CALL allocate_field(f_qu,field_u,type_real,llm) 
-  
-  CALL allocate_field(f_buf_i,field_t,type_real,llm)
-  CALL allocate_field(f_buf_p,field_t,type_real,llm+1)
-  CALL allocate_field(f_buf_u3d,field_t,type_real,3,llm)  ! 3D vel at cell centers
-  CALL allocate_field(f_buf_ulon,field_t,type_real,llm)
-  CALL allocate_field(f_buf_ulat,field_t,type_real,llm)
-  CALL allocate_field(f_buf_v,field_z,type_real,llm)
-  CALL allocate_field(f_buf_s,field_t,type_real)
+    CALL allocate_field(f_out_u,field_u,type_real,llm) 
+    CALL allocate_field(f_p,field_t,type_real,llm+1)
+    CALL allocate_field(f_rhodz,field_t,type_real,llm) 
+    CALL allocate_field(f_qu,field_u,type_real,llm) 
+  
+    CALL allocate_field(f_buf_i,field_t,type_real,llm)
+    CALL allocate_field(f_buf_p,field_t,type_real,llm+1) 
+    CALL allocate_field(f_buf_u3d,field_t,type_real,3,llm)  ! 3D vel at cell centers
+    CALL allocate_field(f_buf_ulon,field_t,type_real,llm)
+    CALL allocate_field(f_buf_ulat,field_t,type_real,llm)
+    CALL allocate_field(f_buf_v,field_z,type_real,llm)
+    CALL allocate_field(f_buf_s,field_t,type_real)
+
+    CALL allocate_field(f_theta,field_t,type_real,llm)  ! potential temperature
+    CALL allocate_field(f_pk,field_t,type_real,llm)
+    CALL allocate_field(f_pks,field_t,type_real) ! Exner function
+    CALL allocate_field(f_phi,field_t,type_real,llm)    ! geopotential
+    CALL allocate_field(f_divm,field_t,type_real,llm)  ! mass flux divergence
+    CALL allocate_field(f_wwuu,field_u,type_real,llm+1) 
 
   END SUBROUTINE allocate_caldyn
@@ -92,4 +109,5 @@
     USE mpipara
     USE trace
+    USE omp_para
     IMPLICIT NONE
     LOGICAL,INTENT(IN)    :: write_out
@@ -108,11 +126,31 @@
     REAL(rstd),POINTER :: u(:,:), du(:,:), hflux(:,:), wflux(:,:)
     REAL(rstd),POINTER :: p(:,:), rhodz(:,:), qu(:,:)
+
+! temporary shared variable
+    REAL(rstd),POINTER  :: theta(:,:)  
+    REAL(rstd),POINTER  :: pk(:,:), pks(:)
+    REAL(rstd),POINTER  :: phi(:,:)    
+    REAL(rstd),POINTER  :: divm(:,:) 
+    REAL(rstd),POINTER  :: wwuu(:,:)
+    
+    
     INTEGER :: ind,ij
+    LOGICAL,SAVE :: first=.TRUE.
+!$OMP THREADPRIVATE(first)
+
+    
+    IF (first) THEN
+      first=.FALSE.
+      CALL init_message(f_ps,req_i1,req_ps)
+      CALL init_message(f_theta_rhodz,req_i1,req_theta_rhodz)
+      CALL init_message(f_u,req_e1_vect,req_u)
+      CALL init_message(f_qu,req_e1_scal,req_qu)
+      CALL send_message(f_ps,req_ps) 
+    ENDIF
     
     CALL trace_start("caldyn")
-    CALL transfert_request(f_phis,req_i1) 
-    CALL transfert_request(f_ps,req_i1) 
-    CALL transfert_request(f_theta_rhodz,req_i1) 
-    CALL transfert_request(f_u,req_e1_vect)
+
+    CALL send_message(f_u,req_u)
+    CALL send_message(f_theta_rhodz,req_theta_rhodz) 
 
     SELECT CASE(caldyn_conserv)
@@ -126,10 +164,10 @@
           qu=f_qu(ind)
           u=f_u(ind)
-          !$OMP PARALLEL DEFAULT(SHARED)
+
           CALL compute_pvort(ps, u, p,rhodz,qu)
-          !$OMP END PARALLEL
+
        ENDDO
 
-       CALL transfert_request(f_qu,req_e1_scal)
+       CALL send_message(f_qu,req_qu)
 
        DO ind=1,ndomain
@@ -148,9 +186,14 @@
           u=f_u(ind)
           du=f_du(ind)
-          out_u=f_out_u(ind) 
-          !$OMP PARALLEL DEFAULT(SHARED)
-          CALL compute_caldyn(ps, u, p,rhodz,qu, phis, theta_rhodz, &
-               hflux, wflux, dps, dtheta_rhodz, du)
-          !$OMP END PARALLEL
+          out_u=f_out_u(ind)
+          theta = f_theta(ind)
+          pk = f_pk(ind)
+          pks = f_pks(ind)
+          phi = f_phi(ind)  
+          divm = f_divm(ind)
+          wwuu=f_wwuu(ind)
+
+          CALL compute_caldyn(ps, u, p,rhodz,qu, phis, theta_rhodz, hflux, wflux, dps, dtheta_rhodz, du, &
+                              theta,pk, pks, phi, divm, wwuu)
        ENDDO       
        
@@ -172,9 +215,8 @@
           du=f_du(ind)
           out_u=f_out_u(ind) 
-          !$OMP PARALLEL DEFAULT(SHARED)
+          wwuu=f_wwuu(ind)
           CALL compute_pvort(ps, u, p,rhodz,qu)
-          CALL compute_caldyn(ps, u, p,rhodz,qu, phis, theta_rhodz, &
-               hflux, wflux, dps, dtheta_rhodz, du)
-          !$OMP END PARALLEL
+          CALL compute_caldyn(ps, u, p,rhodz,qu, phis, theta_rhodz, hflux, wflux, dps, dtheta_rhodz, du,   &
+                              theta,pk, pks, phi, divm, wwuu)
        ENDDO
        
@@ -183,12 +225,22 @@
     END SELECT
 
+!$OMP BARRIER
     IF (write_out) THEN
+
        IF (is_mpi_root) PRINT *,'CALL write_output_fields'
-       CALL write_output_fields(f_ps, f_phis, f_dps, f_u, f_theta_rhodz, f_q, &
-            f_buf_i, f_buf_v, f_buf_u3d, f_buf_ulon, f_buf_ulat, f_buf_s, f_buf_p)
+
+! ---> for openMP test to fix later
+!       CALL write_output_fields(f_ps, f_phis, f_dps, f_u, f_theta_rhodz, f_q, &
+!            f_buf_i, f_buf_v, f_buf_u3d, f_buf_ulon, f_buf_ulat, f_buf_s, f_buf_p)
+       CALL writefield("ps",f_ps)
+       CALL writefield("dps",f_dps)
+       CALL writefield("vort",f_qu)
+       CALL writefield("theta",f_theta)
+
     END IF
     
     !    CALL check_mass_conservation(f_ps,f_dps)
     CALL trace_end("caldyn")
+!$OMP BARRIER
     
 END SUBROUTINE caldyn
@@ -199,4 +251,5 @@
   USE exner_mod
   USE trace
+  USE omp_para
   IMPLICIT NONE
   REAL(rstd),INTENT(IN)  :: u(iim*3*jjm,llm)
@@ -208,19 +261,14 @@
   INTEGER :: i,j,ij,l
   REAL(rstd) :: etav,hv
-  REAL(rstd),ALLOCATABLE,SAVE :: qv(:,:)     ! potential velocity  
-  
-  LOGICAL,SAVE :: first=.TRUE.
-  !$OMP THREADPRIVATE(first)
-
+  REAL(rstd) :: qv(2*iim*jjm,llm)     ! potential velocity  
+  
 
   CALL trace_start("compute_pvort")  
-  !$OMP BARRIER      
-  !$OMP MASTER  
-  !    IF (first) THEN
-  ALLOCATE(qv(2*iim*jjm,llm))     ! potential velocity  
-  
+
+  CALL wait_message(req_ps)   
 !!! Compute pressure
-  DO    l    = 1, llm+1
-     !$OMP DO
+   DO    l    = ll_begin, ll_endp1
+    CALL test_message(req_u) 
+
      DO j=jj_begin-1,jj_end+1
         DO i=ii_begin-1,ii_end+1
@@ -230,8 +278,10 @@
      ENDDO
   ENDDO
-  
+
+!$OMP BARRIER  
+
 !!! Compute mass
-  DO l = 1, llm
-     !$OMP DO
+   DO l = ll_begin,ll_end
+     CALL test_message(req_u) 
      DO j=jj_begin-1,jj_end+1
         DO i=ii_begin-1,ii_end+1
@@ -241,15 +291,18 @@
      ENDDO
   ENDDO
+
+  CALL wait_message(req_u)   
   
 !!! Compute shallow-water potential vorticity
-  DO l = 1,llm
-!$OMP DO
+  DO l = ll_begin,ll_end
+    CALL test_message(req_theta_rhodz) 
+
     DO j=jj_begin-1,jj_end+1
        DO i=ii_begin-1,ii_end+1
           ij=(j-1)*iim+i
           
-          etav= 1./Av(ij+z_up)*(  ne(ij,rup)        * u(ij+u_rup,l)        * de(ij+u_rup)         &
-                                + ne(ij+t_rup,left) * u(ij+t_rup+u_left,l) * de(ij+t_rup+u_left)  &
-                                - ne(ij,lup)        * u(ij+u_lup,l)        * de(ij+u_lup) )                               
+          etav= 1./Av(ij+z_up)*(  ne_rup        * u(ij+u_rup,l)        * de(ij+u_rup)         &
+                                + ne_left * u(ij+t_rup+u_left,l) * de(ij+t_rup+u_left)  &
+                                - ne_lup        * u(ij+u_lup,l)        * de(ij+u_lup) )                               
 
           hv =  Riv2(ij,vup)          * rhodz(ij,l)            &
@@ -259,7 +312,7 @@
           qv(ij+z_up,l) = ( etav+fv(ij+z_up) )/hv
           
-          etav = 1./Av(ij+z_down)*(  ne(ij,ldown)         * u(ij+u_ldown,l)          * de(ij+u_ldown)          &
-                                   + ne(ij+t_ldown,right) * u(ij+t_ldown+u_right,l)  * de(ij+t_ldown+u_right)  &
-                                   - ne(ij,rdown)         * u(ij+u_rdown,l)          * de(ij+u_rdown) )
+          etav = 1./Av(ij+z_down)*(  ne_ldown         * u(ij+u_ldown,l)          * de(ij+u_ldown)          &
+                                   + ne_right * u(ij+t_ldown+u_right,l)  * de(ij+t_ldown+u_right)  &
+                                   - ne_rdown         * u(ij+u_rdown,l)          * de(ij+u_rdown) )
        
           hv =  Riv2(ij,vdown)        * rhodz(ij,l)          &
@@ -283,18 +336,16 @@
    ENDDO
 
-!!$OMP BARRIER
-!!$OMP MASTER  
-    DEALLOCATE(qv)       ! potential velocity  
-!!$OMP END MASTER
-!!$OMP BARRIER   
-    CALL trace_end("compute_pvort")
+   CALL trace_end("compute_pvort")
                                                        
   END SUBROUTINE compute_pvort
-  
-  SUBROUTINE compute_caldyn(ps, u, p,rhodz,qu, phis, theta_rhodz, hflux, wflux, dps, dtheta_rhodz, du)
+
+  
+  SUBROUTINE compute_caldyn(ps, u, p,rhodz,qu, phis, theta_rhodz, hflux, wflux, dps, dtheta_rhodz, du,   &
+                            theta,pk, pks, phi, divm, wwuu) 
   USE icosa
   USE disvert_mod
   USE exner_mod
   USE trace
+  USE omp_para
   IMPLICIT NONE
     REAL(rstd),INTENT(IN)  :: phis(iim*jjm)
@@ -310,36 +361,26 @@
     REAL(rstd),INTENT(OUT) :: dps(iim*jjm)
     REAL(rstd),INTENT(OUT) :: wflux(iim*jjm,llm+1) ! vertical mass flux (kg/m2/s)
-    
-    REAL(rstd),ALLOCATABLE,SAVE :: theta(:,:)  ! potential temperature
-    REAL(rstd),ALLOCATABLE,SAVE :: pk(:,:), pks(:) ! Exner function
-    REAL(rstd),ALLOCATABLE,SAVE :: alpha(:,:), beta(:,:)
-    REAL(rstd),ALLOCATABLE,SAVE :: phi(:,:)    ! geopotential
-    REAL(rstd),ALLOCATABLE,SAVE :: Ftheta(:,:) ! theta flux
-    REAL(rstd),ALLOCATABLE,SAVE :: divm(:,:)  ! mass flux divergence
-    REAL(rstd),ALLOCATABLE,SAVE :: berni(:,:)  ! Bernouilli function
+
+! temporary variable
+    REAL(rstd),INTENT(INOUT) :: theta(iim*jjm,llm)  ! potential temperature
+    REAL(rstd),INTENT(INOUT) :: pk(iim*jjm,llm), pks(iim*jjm) ! Exner function
+    REAL(rstd),INTENT(INOUT) :: phi(iim*jjm,llm)    ! geopotential
+    REAL(rstd),INTENT(INOUT) :: divm(iim*jjm,llm)  ! mass flux divergence
+    REAL(rstd),INTENT(INOUT) :: wwuu(iim*3*jjm,llm+1)
+
+    
+    REAL(rstd) :: Ftheta(3*iim*jjm,llm) ! theta flux
+    REAL(rstd) :: berni(iim*jjm,llm)  ! Bernouilli function
     
     INTEGER :: i,j,ij,l
     REAL(rstd) :: ww,uu
 
-    LOGICAL,SAVE :: first=.TRUE.
-!$OMP THREADPRIVATE(first)
-    
     CALL trace_start("compute_caldyn")
-!$OMP BARRIER      
-!$OMP MASTER  
-!    IF (first) THEN
-    ALLOCATE(theta(iim*jjm,llm))    ! potential temperature
-    ALLOCATE(pk(iim*jjm,llm))       ! Exner function
-    ALLOCATE(pks(iim*jjm))
-    ALLOCATE(alpha(iim*jjm,llm))
-    ALLOCATE(beta(iim*jjm,llm))
-    ALLOCATE(phi(iim*jjm,llm))      ! geopotential
-    ALLOCATE(Ftheta(3*iim*jjm,llm)) ! theta flux   
-    ALLOCATE(divm(iim*jjm,llm))    ! mass flux divvergence
-    ALLOCATE(berni(iim*jjm,llm))    ! bernouilli term
+
+    CALL wait_message(req_theta_rhodz) 
 
 !!! Compute theta
-   DO l = 1, llm
-!$OMP DO
+   DO l = ll_begin, ll_end
+      IF (caldyn_conserv==energy) CALL test_message(req_qu) 
       DO j=jj_begin-1,jj_end+1
          DO i=ii_begin-1,ii_end+1
@@ -350,6 +391,7 @@
    ENDDO
 
-  DO l = 1, llm
+  DO l = ll_begin, ll_end
 !!!  Compute mass and theta fluxes
+    IF (caldyn_conserv==energy) CALL test_message(req_qu) 
     DO j=jj_begin-1,jj_end+1
       DO i=ii_begin-1,ii_end+1
@@ -370,26 +412,28 @@
         ij=(j-1)*iim+i  
         ! divm = +div(mass flux), sign convention as in Ringler et al. 2012, eq. 21
-        divm(ij,l)= 1./Ai(ij)*(ne(ij,right)*hflux(ij+u_right,l)   +  &
-                                ne(ij,rup)*hflux(ij+u_rup,l)       +  &  
-                                ne(ij,lup)*hflux(ij+u_lup,l)       +  &  
-                                ne(ij,left)*hflux(ij+u_left,l)     +  &  
-                                ne(ij,ldown)*hflux(ij+u_ldown,l)   +  &  
-                                ne(ij,rdown)*hflux(ij+u_rdown,l))    
+        divm(ij,l)= 1./Ai(ij)*(ne_right*hflux(ij+u_right,l)   +  &
+                                ne_rup*hflux(ij+u_rup,l)       +  &  
+                                ne_lup*hflux(ij+u_lup,l)       +  &  
+                                ne_left*hflux(ij+u_left,l)     +  &  
+                                ne_ldown*hflux(ij+u_ldown,l)   +  &  
+                                ne_rdown*hflux(ij+u_rdown,l))    
 
         ! signe ? attention d (rho theta dz)
         ! dtheta_rhodz =  -div(flux.theta)
-        dtheta_rhodz(ij,l)=-1./Ai(ij)*(ne(ij,right)*Ftheta(ij+u_right,l)    +  &
-                                 ne(ij,rup)*Ftheta(ij+u_rup,l)        +  &  
-                                 ne(ij,lup)*Ftheta(ij+u_lup,l)        +  &  
-                                 ne(ij,left)*Ftheta(ij+u_left,l)      +  &  
-                                 ne(ij,ldown)*Ftheta(ij+u_ldown,l)    +  &  
-                                 ne(ij,rdown)*Ftheta(ij+u_rdown,l))
+        dtheta_rhodz(ij,l)=-1./Ai(ij)*(ne_right*Ftheta(ij+u_right,l)    +  &
+                                 ne_rup*Ftheta(ij+u_rup,l)        +  &  
+                                 ne_lup*Ftheta(ij+u_lup,l)        +  &  
+                                 ne_left*Ftheta(ij+u_left,l)      +  &  
+                                 ne_ldown*Ftheta(ij+u_ldown,l)    +  &  
+                                 ne_rdown*Ftheta(ij+u_rdown,l))
       ENDDO
     ENDDO
   ENDDO
-   
+
+!$OMP BARRIER   
 !!! cumulate mass flux divergence from top to bottom
   DO  l = llm-1, 1, -1
-!$OMP DO
+    IF (caldyn_conserv==energy) CALL test_message(req_qu) 
+!$OMP DO SCHEDULE(STATIC) 
     DO j=jj_begin,jj_end
       DO i=ii_begin,ii_end
@@ -399,8 +443,12 @@
     ENDDO
   ENDDO
+
+! IMPLICIT FLUSH on divm
+!!!!!!!!!!!!!!!!!!!!!!!!!
   
 !!! Compute vertical mass flux
-  DO l = 1,llm-1
-!$OMP DO
+!  DO l = 2,llm
+  DO l=ll_beginp1,ll_end
+    IF (caldyn_conserv==energy) CALL test_message(req_qu) 
     DO j=jj_begin,jj_end
       DO i=ii_begin,ii_end
@@ -408,5 +456,5 @@
         ! w = int(z,ztop,div(flux)dz) + B(eta)dps/dt
         ! => w>0 for upward transport
-        wflux( ij, l+1 ) = divm( ij, l+1 ) - bp(l+1) * divm( ij, 1 )
+        wflux( ij, l ) = divm( ij, l ) - bp(l) * divm( ij, 1 )
       ENDDO
     ENDDO
@@ -414,15 +462,24 @@
 
 ! compute dps, set vertical mass flux at the surface to 0
-!$OMP DO
-  DO j=jj_begin,jj_end
-    DO i=ii_begin,ii_end
-      ij=(j-1)*iim+i
-      wflux(ij,1)  = 0.
-      wflux(ij,llm+1)  = 0.
-      ! dps/dt = -int(div flux)dz
-      dps(ij)=-divm(ij,1) * g 
-    ENDDO
-  ENDDO
-
+  IF (omp_first) THEN
+    DO j=jj_begin,jj_end
+      DO i=ii_begin,ii_end
+        ij=(j-1)*iim+i
+        wflux(ij,1)  = 0.
+        ! dps/dt = -int(div flux)dz
+        dps(ij)=-divm(ij,1) * g 
+      ENDDO
+    ENDDO
+  ENDIF
+
+
+  IF (omp_last) THEN
+    DO j=jj_begin,jj_end
+      DO i=ii_begin,ii_end
+        ij=(j-1)*iim+i
+        wflux(ij,llm+1)  = 0.
+      ENDDO
+    ENDDO
+  ENDIF
 !!! Compute potential vorticity (Coriolis) contribution to du
 
@@ -430,6 +487,7 @@
     CASE(energy) ! energy-conserving TRiSK
 
-       DO l=1,llm
-          !$OMP DO
+       CALL wait_message(req_qu)
+
+        DO l=ll_begin,ll_end
           DO j=jj_begin,jj_end
              DO i=ii_begin,ii_end
@@ -479,6 +537,5 @@
     CASE(enstrophy) ! enstrophy-conserving TRiSK
   
-       DO l=1,llm
-          !$OMP DO
+        DO l=ll_begin,ll_end
           DO j=jj_begin,jj_end
              DO i=ii_begin,ii_end
@@ -531,19 +588,53 @@
   
 !!! Compute Exner function
-!    PRINT *, 'Computing Exner'
-    CALL compute_exner(ps,p,pks,pk,1) 
+!    CALL compute_exner(ps,p,pks,pk,1) 
+! replaced in source
+    IF (omp_first) THEN    
+       DO j=jj_begin-1,jj_end+1
+          DO i=ii_begin-1,ii_end+1
+             ij=(j-1)*iim+i
+             pks(ij) = cpp * ( ps(ij)/preff ) ** kappa
+          ENDDO
+       ENDDO
+     ENDIF
+     
+       ! 3D : pk
+     DO l = ll_begin, ll_end
+        DO j=jj_begin-1,jj_end+1
+           DO i=ii_begin-1,ii_end+1
+              ij=(j-1)*iim+i
+              pk(ij,l) = cpp * ((.5/preff)*(p(ij,l)+p(ij,l+1))) ** kappa
+           ENDDO
+        ENDDO
+     ENDDO
+
+!---> flush pk,pks, theta
+!$OMP BARRIER
 
 !!! Compute geopotential
 
   ! for first layer
-!$OMP DO
-   DO j=jj_begin-1,jj_end+1
-     DO i=ii_begin-1,ii_end+1
-       ij=(j-1)*iim+i
-       phi( ij,1 ) = phis( ij ) + theta(ij,1) * ( pks(ij) - pk(ij,1) )
+  IF (omp_first) THEN
+    DO j=jj_begin-1,jj_end+1
+      DO i=ii_begin-1,ii_end+1
+        ij=(j-1)*iim+i
+        phi( ij,1 ) = phis( ij ) + theta(ij,1) * ( pks(ij) - pk(ij,1) )
+      ENDDO
+    ENDDO
+  ENDIF
+!!-> implicit flush on phi(:,1)
+          
+  ! for other layers
+   DO l = ll_beginp1, ll_end
+     DO j=jj_begin-1,jj_end+1
+       DO i=ii_begin-1,ii_end+1
+         ij=(j-1)*iim+i
+         phi(ij,l) =  0.5 * ( theta(ij,l)  + theta(ij,l-1) )  & 
+                          * (  pk(ij,l-1) -  pk(ij,l)    )
+       ENDDO
      ENDDO
    ENDDO
-          
-  ! for other layers
+
+!$OMP BARRIER
    DO l = 2, llm
 !$OMP DO
@@ -551,14 +642,12 @@
        DO i=ii_begin-1,ii_end+1
          ij=(j-1)*iim+i
-         phi(ij,l) = phi(ij,l-1) + 0.5 * ( theta(ij,l)  + theta(ij,l-1) )  & 
-                                       * (  pk(ij,l-1) -  pk(ij,l)    )
+         phi(ij,l) = phi(ij,l)+ phi(ij,l-1)
        ENDDO
      ENDDO
    ENDDO
-
-   
+! --> IMPLICIT FLUSH on phi
+      
 !!! Compute bernouilli term = Kinetic Energy + geopotential
-  DO l=1,llm
-!$OMP DO
+   DO l=ll_begin,ll_end
     DO j=jj_begin,jj_end
       DO i=ii_begin,ii_end
@@ -576,84 +665,100 @@
     ENDDO
   ENDDO
-  
+
  
 !!! gradients of Bernoulli and Exner functions
-  DO l=1,llm
-!$OMP DO
+
+   DO l=ll_begin,ll_end
     DO j=jj_begin,jj_end
       DO i=ii_begin,ii_end
         ij=(j-1)*iim+i
         
-        out_u(ij+u_right,l)=  1/de(ij+u_right) * (                              &
-                          0.5*(theta(ij,l)+theta(ij+t_right,l))                             &
-                             *( ne(ij,right)*pk(ij,l)+ne(ij+t_right,left)*pk(ij+t_right,l)) &
-                        + ne(ij,right)*berni(ij,l)+ne(ij+t_right,left)*berni(ij+t_right,l) )
+        du(ij+u_right,l) = du(ij+u_right,l) + 1/de(ij+u_right) * (             &
+                          0.5*(theta(ij,l)+theta(ij+t_right,l))                &
+                             *( ne_right*pk(ij,l)+ne_left*pk(ij+t_right,l))    &
+                        + ne_right*berni(ij,l)+ne_left*berni(ij+t_right,l) )
         
-        du(ij+u_right,l) = du(ij+u_right,l) + out_u(ij+u_right,l)
         
-        out_u(ij+u_lup,l)=  1/de(ij+u_lup) * (                                  &
-                          0.5*(theta(ij,l)+theta(ij+t_lup,l))                             &
-                             *( ne(ij,lup)*pk(ij,l)+ne(ij+t_lup,rdown)*pk(ij+t_lup,l))    &
-                        + ne(ij,lup)*berni(ij,l)+ne(ij+t_lup,rdown)*berni(ij+t_lup,l) )
-        
-        du(ij+u_lup,l) = du(ij+u_lup,l) + out_u(ij+u_lup,l)
+        du(ij+u_lup,l) = du(ij+u_lup,l) +  1/de(ij+u_lup) * (                  &
+                          0.5*(theta(ij,l)+theta(ij+t_lup,l))                  &
+                             *( ne_lup*pk(ij,l)+ne_rdown*pk(ij+t_lup,l))       &
+                        + ne_lup*berni(ij,l)+ne_rdown*berni(ij+t_lup,l) )
                 
-        out_u(ij+u_ldown,l)= 1/de(ij+u_ldown) * (                                &
-                          0.5*(theta(ij,l)+theta(ij+t_ldown,l))                               &
-                             *( ne(ij,ldown)*pk(ij,l)+ne(ij+t_ldown,rup)*pk(ij+t_ldown,l))    &
-                        + ne(ij,ldown)*berni(ij,l)+ne(ij+t_ldown,rup)*berni(ij+t_ldown,l) )
-        
-        du(ij+u_ldown,l) = du(ij+u_ldown,l) + out_u(ij+u_ldown,l)
+        du(ij+u_ldown,l) = du(ij+u_ldown,l) + 1/de(ij+u_ldown) * (             &
+                          0.5*(theta(ij,l)+theta(ij+t_ldown,l))                &
+                             *( ne_ldown*pk(ij,l)+ne_rup*pk(ij+t_ldown,l))     &
+                        + ne_ldown*berni(ij,l)+ne_rup*berni(ij+t_ldown,l) )
 
       ENDDO
     ENDDO
   ENDDO
- 
-!!! contributions of vertical advection to du, dtheta
- 
-  DO l=1,llm-1
-!$OMP DO
-    DO j=jj_begin,jj_end
-      DO i=ii_begin,ii_end
-        ij=(j-1)*iim+i
-         ! ww>0 <=> upward transport
-
-        ww            =   0.5 * wflux(ij,l+1) * (theta(ij,l) + theta(ij,l+1) )
-        dtheta_rhodz(ij, l ) = dtheta_rhodz(ij, l )  -  ww
-        dtheta_rhodz(ij,l+1) = dtheta_rhodz(ij,l+1)  +  ww
-
-        ww  = 0.5 * ( wflux(ij,l+1) + wflux(ij+t_right,l+1))
-        uu  = u(ij+u_right,l+1) - u(ij+u_right,l)  
-        du(ij+u_right, l )   = du(ij+u_right,l)   - 0.5 * ww * uu / (0.5*(rhodz(ij,l)+rhodz(ij+t_right,l)))
-        du(ij+u_right, l+1 ) = du(ij+u_right,l+1) - 0.5 * ww * uu / (0.5*(rhodz(ij,l+1)+rhodz(ij+t_right,l+1)))
-
-        ww  = 0.5 * ( wflux(ij,l+1) + wflux(ij+t_lup,l+1))
-        uu  = u(ij+u_lup,l+1) - u(ij+u_lup,l)  
-        du(ij+u_lup, l )   = du(ij+u_lup,l)   - 0.5 * ww * uu / (0.5*(rhodz(ij,l)+rhodz(ij+t_lup,l)))
-        du(ij+u_lup, l+1 ) = du(ij+u_lup,l+1) - 0.5 * ww * uu / (0.5*(rhodz(ij,l+1)+rhodz(ij+t_lup,l+1)))
-
-        ww  = 0.5 * ( wflux(ij,l+1) + wflux(ij+t_ldown,l+1))
-        uu  = u(ij+u_ldown,l+1) - u(ij+u_ldown,l)  
-        du(ij+u_ldown, l )   = du(ij+u_ldown,l)   - 0.5 * ww * uu / (0.5*(rhodz(ij,l)+rhodz(ij+t_ldown,l)))
-        du(ij+u_ldown, l+1 ) = du(ij+u_ldown,l+1) - 0.5 * ww * uu / (0.5*(rhodz(ij,l+1)+rhodz(ij+t_ldown,l+1)))
-
+
+   
+  DO l=ll_begin,ll_endm1
+    DO j=jj_begin,jj_end
+      DO i=ii_begin,ii_end
+        ij=(j-1)*iim+i
+        dtheta_rhodz(ij, l ) = dtheta_rhodz(ij, l )  -   0.5 * (  wflux(ij,l+1) * (theta(ij,l) + theta(ij,l+1)))
+      ENDDO
+    ENDDO
+  ENDDO
+  
+  DO l=ll_beginp1,ll_end
+    DO j=jj_begin,jj_end
+      DO i=ii_begin,ii_end
+        ij=(j-1)*iim+i
+        dtheta_rhodz(ij, l ) = dtheta_rhodz(ij, l )  +   0.5 * ( wflux(ij,l  ) * (theta(ij,l-1) + theta(ij,l) ) )
+      ENDDO
+    ENDDO
+  ENDDO
+  
+  IF (omp_first) THEN
+    DO j=jj_begin,jj_end
+      DO i=ii_begin,ii_end
+        ij=(j-1)*iim+i
+        wwuu(ij+u_right,1)=0   
+        wwuu(ij+u_lup,1)=0   
+        wwuu(ij+u_ldown,1)=0
+      ENDDO
+    ENDDO
+  ENDIF   
+
+  IF (omp_last) THEN
+    DO j=jj_begin,jj_end
+      DO i=ii_begin,ii_end
+        ij=(j-1)*iim+i
+        wwuu(ij+u_right,llm+1)=0   
+        wwuu(ij+u_lup,llm+1)=0   
+        wwuu(ij+u_ldown,llm+1)=0
+      ENDDO
+    ENDDO
+  ENDIF   
+  
+  DO l=ll_beginp1,ll_end
+    DO j=jj_begin,jj_end
+      DO i=ii_begin,ii_end
+        ij=(j-1)*iim+i
+        wwuu(ij+u_right,l) = 0.5*( wflux(ij,l) + wflux(ij+t_right,l)) * (u(ij+u_right,l) - u(ij+u_right,l-1))
+        wwuu(ij+u_lup,l) = 0.5* ( wflux(ij,l) + wflux(ij+t_lup,l)) * (u(ij+u_lup,l) - u(ij+u_lup,l-1))
+        wwuu(ij+u_ldown,l) = 0.5*( wflux(ij,l) + wflux(ij+t_ldown,l)) * (u(ij+u_ldown,l) - u(ij+u_ldown,l-1))
+       ENDDO
+     ENDDO
+   ENDDO
+
+ !--> flush wwuu  
+ !$OMP BARRIER
+
+  DO l=ll_begin,ll_end
+    DO j=jj_begin,jj_end
+      DO i=ii_begin,ii_end
+        ij=(j-1)*iim+i
+        du(ij+u_right, l )   = du(ij+u_right,l)  - (wwuu(ij+u_right,l+1)+ wwuu(ij+u_right,l)) / (rhodz(ij,l)+rhodz(ij+t_right,l))
+        du(ij+u_lup, l )     = du(ij+u_lup,l)    - (wwuu(ij+u_lup,l+1)  + wwuu(ij+u_lup,l))   / (rhodz(ij,l)+rhodz(ij+t_lup,l))
+        du(ij+u_ldown, l )   = du(ij+u_ldown,l)  - (wwuu(ij+u_ldown,l+1)+ wwuu(ij+u_ldown,l)) / (rhodz(ij,l)+rhodz(ij+t_ldown,l))
       ENDDO
     ENDDO
   ENDDO      
-   
-!!$OMP BARRIER
-!!$OMP MASTER  
-    DEALLOCATE(theta)   ! potential temperature
-    DEALLOCATE(pk)      ! Exner function
-    DEALLOCATE(pks)
-    DEALLOCATE(alpha)
-    DEALLOCATE(beta)
-    DEALLOCATE(phi)     ! geopotential
-    DEALLOCATE(Ftheta)  ! theta flux   
-    DEALLOCATE(divm)    ! mass flux divergence
-    DEALLOCATE(berni)   ! bernouilli term
-!!$OMP END MASTER
-!!$OMP BARRIER                                                      
-    CALL trace_end("compute_caldyn")
+  
+  CALL trace_end("compute_caldyn")
 
   END SUBROUTINE compute_caldyn
@@ -709,4 +814,5 @@
     USE write_field
     USE vertical_interp_mod
+    USE wind_mod
     TYPE(t_field),POINTER :: f_ps(:), f_phis(:), f_u(:), f_theta_rhodz(:), f_q(:), f_dps(:), &
          f_buf_i(:), f_buf_v(:), f_buf_i3(:), f_buf1_i(:), f_buf2_i(:), f_buf_s(:), f_buf_p(:)
@@ -722,15 +828,15 @@
     
     CALL writefield("ps",f_ps)
-!    CALL writefield("dps",f_dps)
-!    CALL writefield("phis",f_phis)
-!    CALL vorticity(f_u,f_buf_v)
-!    CALL writefield("vort",f_buf_v)
-
-!    CALL w_omega(f_ps, f_u, f_buf_i)
-!    CALL writefield('omega', f_buf_i)
-!    IF (out_pression_level<=preff .AND. out_pression_level > 0) THEN
-!      CALL vertical_interp(f_ps,f_buf_i,f_buf_s,out_pression_level)
-!      CALL writefield("omega"//TRIM(str_pression),f_buf_s)
-!    ENDIF
+    CALL writefield("dps",f_dps)
+    CALL writefield("phis",f_phis)
+    CALL vorticity(f_u,f_buf_v)
+    CALL writefield("vort",f_buf_v)
+
+    CALL w_omega(f_ps, f_u, f_buf_i)
+    CALL writefield('omega', f_buf_i)
+    IF (out_pression_level<=preff .AND. out_pression_level > 0) THEN
+      CALL vertical_interp(f_ps,f_buf_i,f_buf_s,out_pression_level)
+      CALL writefield("omega"//TRIM(str_pression),f_buf_s)
+    ENDIF
     
     ! Temperature
@@ -754,5 +860,5 @@
    
     ! velocity components
-    CALL un2ulonlat(f_u, f_buf_i3, f_buf1_i, f_buf2_i)
+    CALL un2ulonlat(f_u, f_buf1_i, f_buf2_i)
     CALL writefield("ulon",f_buf1_i)
     CALL writefield("ulat",f_buf2_i)
@@ -767,8 +873,8 @@
     ! geopotential
     CALL thetarhodz2geopot(f_ps,f_phis,f_theta_rhodz, f_buf_s,f_buf_p,f_buf1_i,f_buf2_i,f_buf_i)
-!    CALL writefield("p",f_buf_p)
-!    CALL writefield("phi",f_buf_i)
-     CALL writefield("theta",f_buf1_i) ! potential temperature
-!    CALL writefield("pk",f_buf2_i) ! Exner pressure
+    CALL writefield("p",f_buf_p)
+    CALL writefield("phi",f_buf_i)
+    CALL writefield("theta",f_buf1_i) ! potential temperature
+    CALL writefield("pk",f_buf2_i) ! Exner pressure
   
   
@@ -806,23 +912,4 @@
   END SUBROUTINE thetarhodz2geopot
   
-  SUBROUTINE un2ulonlat(f_u, f_u3d, f_ulon, f_ulat)
-    USE field_mod
-    USE wind_mod
-    TYPE(t_field), POINTER :: f_u(:), & ! IN  : normal velocity components on edges
-         f_u3d(:), f_ulon(:), f_ulat(:) ! OUT : velocity reconstructed at hexagons
-    REAL(rstd),POINTER :: u(:,:), u3d(:,:,:), ulon(:,:), ulat(:,:)
-    INTEGER :: ind
-    DO ind=1,ndomain
-       CALL swap_dimensions(ind)
-       CALL swap_geometry(ind)
-       u=f_u(ind)
-       u3d=f_u3d(ind)
-       CALL compute_wind_centered(u,u3d)
-       ulon=f_ulon(ind)
-       ulat=f_ulat(ind)
-       CALL compute_wind_centered_lonlat_compound(u3d, ulon, ulat)
-    END DO
-  END SUBROUTINE un2ulonlat
-
   SUBROUTINE Tv2T(f_Tv, f_q, f_T)
   USE icosa
